import * as React from "react";
import useResizeObserver from '@react-hook/resize-observer';
//import ResizeObserver from "resize-observer-polyfill";
/* 新的包 @react-hook/resize-observer 接替本hook;
注意：注入Spring动画时 const width= useMeasure(containerRef)?.width | 0;  避免报错NaN;
[没有立刻提供Ref?.current]的场景；上级组件用useMeasure(ref)可能遇见ref没有实际DOM显示，必须等待按钮揭示出来的情形，如下的解决做法。
遇到了：useMeasure无法测量，不能依据target.current来重新去登記useResizeObserver，导致失效的！
@举例 函数组件如下的 {
       const szTil=useMeasure(target.current? target : null);  不能用const szTil=useMeasure(target);
       这个时间target.current还是为null; 需要点击按钮才有新值！
       const instrumentTable= React.useMemo(() =>
          {
            return <div>
                    <div ref={target} 。。。
               </div>;
          } ,[target, ]);
     return  <Collapse > 需要点击: target才能真的显示DOM;
                {instrumentTable}
            </Collapse>
        }
* */
export const useMeasure = (target) => {
    // if(target?.current==null)  return null;  @报错！！
    const [size, setSize] = React.useState();
    // readonly width: number;
    // readonly height: number;
    // readonly left: number;
    // readonly top: number;
    //@报错！ Hooks can only be called inside of the body of a function component.
    // const handleReset = React.useCallback(() => {
    //     useResizeObserver(target, (entry) => {setSize(entry.contentRect)
    //         console.log("useResizeObserver=", entry);
    //     })
    // }, [target?.current, setSize]);
    React.useLayoutEffect(() => {
        target?.current && setSize(target?.current.getBoundingClientRect());
    }, [target, target?.current, setSize]);
    useResizeObserver(target, (entry) => {
        setSize(entry.contentRect);
    });
    return (target?.current ? size : undefined);
};
//export function useMeasure(ref: React.MutableRefObject<any>) {  return { bounds };
//# sourceMappingURL=use-measure.js.map